Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 1 | # |
| 2 | # Copyright (c) 2011 The Chromium OS Authors. |
| 3 | # |
Wolfgang Denk | 1a45966 | 2013-07-08 09:37:19 +0200 | [diff] [blame^] | 4 | # SPDX-License-Identifier: GPL-2.0+ |
Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 5 | # |
| 6 | |
| 7 | # This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is |
| 8 | # enabled. See doc/README.fdt-control for more details. |
| 9 | |
| 10 | include $(TOPDIR)/config.mk |
| 11 | |
| 12 | LIB = $(obj)libdts.o |
| 13 | |
Jagannadha Sutradharudu Teki | 74de8c9 | 2013-02-28 10:20:18 +0000 | [diff] [blame] | 14 | ifeq ($(DEVICE_TREE),) |
Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 15 | $(if $(CONFIG_DEFAULT_DEVICE_TREE),,\ |
| 16 | $(error Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file)) |
| 17 | DEVICE_TREE = $(subst ",,$(CONFIG_DEFAULT_DEVICE_TREE)) |
Jagannadha Sutradharudu Teki | 74de8c9 | 2013-02-28 10:20:18 +0000 | [diff] [blame] | 18 | endif |
Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 19 | |
| 20 | $(if $(CONFIG_ARCH_DEVICE_TREE),,\ |
| 21 | $(error Your architecture does not have device tree support enabled. \ |
| 22 | Please define CONFIG_ARCH_DEVICE_TREE)) |
| 23 | |
| 24 | # We preprocess the device tree file provide a useful define |
Allen Martin | 6487d88 | 2013-01-08 16:07:54 +0000 | [diff] [blame] | 25 | DTS_CPPFLAGS := -x assembler-with-cpp \ |
Horst Kronstorfer | b4f106b | 2012-07-13 03:03:40 +0000 | [diff] [blame] | 26 | -DARCH_CPU_DTS=\"$(SRCTREE)/arch/$(ARCH)/dts/$(CONFIG_ARCH_DEVICE_TREE).dtsi\" \ |
Tom Warren | 6c5be64 | 2013-02-21 12:31:27 +0000 | [diff] [blame] | 27 | -DBOARD_DTS=\"$(SRCTREE)/board/$(VENDOR)/$(BOARD)/dts/$(DEVICE_TREE).dts\" \ |
| 28 | -I$(SRCTREE)/board/$(VENDOR)/dts -I$(SRCTREE)/arch/$(ARCH)/dts |
Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 29 | |
| 30 | all: $(obj).depend $(LIB) |
| 31 | |
| 32 | # Use a constant name for this so we can access it from C code. |
| 33 | # objcopy doesn't seem to allow us to set the symbol name independently of |
| 34 | # the filename. |
| 35 | DT_BIN := $(obj)dt.dtb |
| 36 | |
| 37 | $(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts |
Wolfgang Denk | 896bbb5 | 2012-04-19 02:36:44 +0000 | [diff] [blame] | 38 | rc=$$( \ |
| 39 | cat $< | $(CPP) -P $(DTS_CPPFLAGS) - | \ |
| 40 | { { $(DTC) -R 4 -p 0x1000 -O dtb -o ${DT_BIN} - 2>&1 ; \ |
| 41 | echo $$? >&3 ; } | \ |
| 42 | grep -v '^DTC: dts->dtb on file' ; \ |
Stephen Warren | 58e22f8 | 2012-06-08 12:28:17 +0000 | [diff] [blame] | 43 | } 3>&1 1>&2 ) ; \ |
Wolfgang Denk | 896bbb5 | 2012-04-19 02:36:44 +0000 | [diff] [blame] | 44 | exit $$rc |
Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 45 | |
| 46 | process_lds = \ |
| 47 | $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p' |
| 48 | |
| 49 | # Run the compiler and get the link script from the linker |
| 50 | GET_LDS = $(CC) $(CFLAGS) $(LDFLAGS) -Wl,--verbose 2>&1 |
| 51 | |
| 52 | $(obj)dt.o: $(DT_BIN) |
| 53 | # We want the output format and arch. |
| 54 | # We also hope to win a prize for ugliest Makefile / shell interaction |
| 55 | # We look in the LDSCRIPT first. |
| 56 | # Then try the linker which should give us the answer. |
| 57 | # Then check it worked. |
Horst Kronstorfer | a4ff471 | 2012-07-12 02:58:32 +0000 | [diff] [blame] | 58 | [ -n "$(LDSCRIPT)" ] && \ |
| 59 | oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` && \ |
| 60 | oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\ |
Simon Glass | bbb0b12 | 2011-10-15 05:48:21 +0000 | [diff] [blame] | 61 | \ |
| 62 | [ -z $${oformat} ] && \ |
| 63 | oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\ |
| 64 | [ -z $${oarch} ] && \ |
| 65 | oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\ |
| 66 | \ |
| 67 | [ -z $${oformat} ] && \ |
| 68 | echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \ |
| 69 | exit 1 || true ;\ |
| 70 | [ -z $${oarch} ] && \ |
| 71 | echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \ |
| 72 | exit 1 || true ;\ |
| 73 | \ |
| 74 | cd $(dir ${DT_BIN}) && \ |
| 75 | $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \ |
| 76 | $(notdir ${DT_BIN}) $@ |
| 77 | rm $(DT_BIN) |
| 78 | |
| 79 | OBJS-$(CONFIG_OF_EMBED) := dt.o |
| 80 | |
| 81 | COBJS := $(OBJS-y) |
| 82 | |
| 83 | OBJS := $(addprefix $(obj),$(COBJS)) |
| 84 | |
| 85 | binary: $(DT_BIN) |
| 86 | |
| 87 | $(LIB): $(OBJS) $(DTB) |
| 88 | $(call cmd_link_o_target, $(OBJS)) |
| 89 | |
| 90 | ######################################################################### |
| 91 | |
| 92 | # defines $(obj).depend target |
| 93 | include $(SRCTREE)/rules.mk |
| 94 | |
| 95 | sinclude $(obj).depend |
| 96 | |
| 97 | ######################################################################### |